.nolist    ; [url=http://www.masm32.com/board/index.php?topic=1807.msg81079#msg81079]http://www.masm32.com/board/index.php?topic=1807.msg81079#msg81079[/url]
include \masm32\include\masm32rt.inc
include \masm32\macros\timers.asm

	; search for SLEEP_MS to see the start of the tests
	CacheFree	= 0
	LOOP_COUNT	= 1000000
	SLEEP_MS	= 1000/5
	BUFSIZE		= LOOP_COUNT*100	; don't go higher than 600...!

    .686
    .mmx
    .xmm

lstrlenA	PROTO:DWORD
strlen32	PROTO:DWORD
strlen32b	PROTO:DWORD
strlen32c	PROTO:DWORD
strlen32s	PROTO:DWORD
strlen64	PROTO:DWORD
strlen64A	PROTO:DWORD
strlen64B	PROTO:DWORD
NWStrLen	PROTO:DWORD
AzmtStrLen1A	PROTO:DWORD
AzmtStrLen2A	PROTO:DWORD
markl_szlen	PROTO:DWORD
StrSizeA	PROTO :DWORD
_strlen	PROTO :DWORD
ShowCPU	PROTO:DWORD
MyTest	PROTO:DWORD, :DWORD
StringLength_Mmx_Min PROTO :DWORD
  
AlgoTest MACRO txt, pAlgo, arg
  % print <txt>
  if CacheFree eq 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke pAlgo, offset arg
	counter_end
	print ustr$(eax)," cycles",13,10
  else
	pushad
	mov esi, len(offset arg)
	add esi, 18			; safe offset
	mov edi, FatBuffer
	xor ebx, ebx
	mov LoopCt, ebx
	print "*"
	.Repeat
		invoke lstrcpy, edi, offset arg
		add edi, esi
		add ebx, esi
		inc LoopCt
	.Until ebx>=BUFSIZE-16384	;  || LoopCt>99	; highest possible length
	print "*"
	mov edi, FatBuffer
	mov ebx, LoopCt
	add ebx, ebx
	add ebx, ebx
	add ebx, ebx	; *8
	print "* "
	invoke GetTickCount
	push eax	; save timer
	push ebx	; save counter
  	.Repeat
		invoke pAlgo, edi
		add edi, esi
		.if edi>BUFSIZE-16384
			mov edi, FatBuffer
		.endif
		add eax, 18
;		.if eax!=esi
;			int 3
;		.endif
		dec ebx
	.Until Zero?
	invoke GetTickCount
	pop ebx
	pop ecx
	sub eax, ecx
	print str$(eax)," ms for "
	print str$(ebx)," loops",13,10
	popad
  endif
ENDM

; 
    .data
	db 0, 0, 0	; misaligned 3
jjTest	db "Ciao jj, why is this algo not working properly ?", 0
	dd 0,0,0,0	; set both xmm0 and xmm1
FatBuffer	dd ?
LoopCt	dd ?
align 16
szTest_0	db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl"
		db 0,0,0,0
      align 16
      db 0
      szTest_1 db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl"
		db 0,0,0,0
      align 16
      dd 0
      szTest_4 db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl"
		db 0

      align 16
      db 0, 0, 0, 0, 0
      szTest_5 db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl "
		db "my other brother darryl my other brother darryl"
		db 0

      align 16
      db 0, 0, 0
      szTest_3 db "my BIG brother "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl"
		db 0

      align 16
      db 0, 0, 0, 0, 0, 0, 0
      szTest_7 db "my BIG brother "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl"
		db 0

      align 16
      db 15 dup (0)
      szTest_15 db "my BIG brother "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl "
;		db "my other brother darryl my other brother darryl"
		db 0

      align 16
      db 15 dup (0)
      szTest_Fail db "my other brother darryl my other brother darryl"
      		db 255, 255, 255, 0

      align 16
      db 15 dup (0)
      szTest_1k	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother", 0
      align 16
      dd 0, 0
      db 0, 0, 0
      szTest_4k	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
      align 16
      szTest_16k	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother"
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother", 0
    .code
; 
start:
; 
	invoke ShowCPU, 1
	if CacheFree
	mov FatBuffer, halloc(BUFSIZE)
	.if eax
		print chr$(13,10)
		print str$(BUFSIZE), " bytes allocated", 13, 10
	.else
		print chr$("Could not allocate buffer", 13, 10)
		exit
	.endif
	endif
	invoke strlen32s, offset jjTest
	; print chr$(13,10)
	; test correctness over a range of 0...4096 bytes:
	; invoke MyTest, strlen64A, chr$("strlen64A")
	invoke MyTest, _strlen, chr$("StrSizeA")
	invoke MyTest, strlen32c, chr$("strlen32c")
	invoke MyTest, strlen32s, chr$("strlen32s")
	invoke MyTest, strlen64B, chr$("strlen64B")
	invoke MyTest, NWStrLen, chr$("NWStrLen")
	invoke MyTest, StringLength_Mmx_Min, chr$("StringLength_Mmx_Min")
	print chr$(13,10)

	print "codesizes: strlen32s="
	mov eax, offset strlen32se-strlen32s
;	print str$(eax), ", strlen32c="
;	mov eax, offset strlen32ce-strlen32c
	print str$(eax), ", strlen64A="
	mov eax, offset strlen64Ae-strlen64A
	print str$(eax), ", strlen64B="
	mov eax, offset strlen64Be-strlen64B
	print str$(eax), ", _strlen="
	mov eax, offset _strlene-_strlen
	print str$(eax), 13, 10

    ; ************************** START of tests ****************************
    print chr$(13, 10)
    invoke Sleep, SLEEP_MS
    
    FOR _sz, <szTest_16k, szTest_4k, szTest_1k, szTest_0, szTest_1, szTest_7, szTest_15>
	txt SUBSTR <_sz>, 8
	txt TEXTEQU <"-- test >,txt,<">
	% print txt, ", misaligned "
	mov edx, offset _sz
	and edx, 15
	print str$(edx), ", "
	print str$(len(offset _sz)), " bytes", 13, 10

	isk INSTR <_sz>, <k>
	if CacheFree
		isk = 0
	endif
	if isk eq 0	; exclude the first two, very slow
		AlgoTest "  Masm32 lib szLen   ", szLen, _sz
		AlgoTest "  crt strlen         ", crt_strlen, _sz
	endif
	if 0	; version c, shorter but slower
		AlgoTest "strlen32c            ", strlen32c, _sz
	endif
	AlgoTest "strlen32s            ", strlen32s, _sz
	; AlgoTest "StringLength_Mmx_Min ", StringLength_Mmx_Min, _sz
	AlgoTest "strlen64LingoB       ", strlen64B, _sz
	AlgoTest "NWStrLen             ", NWStrLen, _sz
	AlgoTest "_strlen (Agner Fog)  ", _strlen, _sz
	print chr$(13, 10)
    ENDM
	if 0 ;SpecialTest
	print "SpecialTest return value: expected="
	print str$(len(offset szTest_Fail)), ", strlen32s="
	invoke strlen32s, ADDR szTest_Fail
	print str$(eax), 13, 10
	endif
    inkey "Press any key to exit..."
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

;
; Returns the string length in EAX and pointer in EDX.
;
; p_lpszStr : Pointer to the string.
;
AzmtStrLen1A PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax

@@:
    mov ecx, dword ptr [edx+eax]
    add eax, 16
    test ecx, 0FFh
    jz @0
    test ecx, 0FF00h
    jz @1
    test ecx, 0FF0000h
    jz @2
    test ecx, 0FF000000h
    jz @3
    mov ecx, dword ptr [edx+eax-12]
    test ecx, 0FFh
    jz @4
    test ecx, 0FF00h
    jz @5
    test ecx, 0FF0000h
    jz @6
    test ecx, 0FF000000h
    jz @7
    mov ecx, dword ptr [edx+eax-8]
    test ecx, 0FFh
    jz @8
    test ecx, 0FF00h
    jz @9
    test ecx, 0FF0000h
    jz @10
    test ecx, 0FF000000h
    jz @11
    mov ecx, dword ptr [edx+eax-4]
    test cl, cl
    jz @12
    test ecx, 0FF00h
    jz @13
    test ecx, 0FF0000h
    jz @14
    test ecx, 0FF000000h
    jnz @B

    sub eax, 1
    ret 4

@0:
    sub eax, 16
    ret 4

@1:
    sub eax, 15
    ret 4

@2:
    sub eax, 14
    ret 4

@3:
    sub eax, 13
    ret 4

@4:
    sub eax, 12
    ret 4

@5:
    sub eax, 11
    ret 4

@6:
    sub eax, 10
    ret 4

@7:
    sub eax, 9
    ret 4

@8:
    sub eax, 8
    ret 4

@9:
    sub eax, 7
    ret 4

@10:
    sub eax, 6
    ret 4

@11:
    sub eax, 5
    ret 4

@12:
    sub eax, 4
    ret 4

@13:
    sub eax, 3
    ret 4

@14:
    sub eax, 2
    ret 4

AzmtStrLen1A ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

;
; Returns the string length in EAX and pointer in EDX.
;
; p_lpszStr : Pointer to the string.
;
AzmtStrLen2A PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax

@@:
    mov ecx, dword ptr [edx+eax]
    add eax, 16
    test cl, cl
    jz @0
    test ch, ch
    jz @1
    test ecx, 0FF0000h
    jz @2
    test ecx, 0FF000000h
    jz @3
    mov ecx, dword ptr [edx+eax-12]
    test cl, cl
    jz @4
    test ch, ch
    jz @5
    test ecx, 0FF0000h
    jz @6
    test ecx, 0FF000000h
    jz @7
    mov ecx, dword ptr [edx+eax-8]
    test cl, cl
    jz @8
    test ch, ch
    jz @9
    test ecx, 0FF0000h
    jz @10
    test ecx, 0FF000000h
    jz @11
    mov ecx, dword ptr [edx+eax-4]
    test cl, cl
    jz @12
    test ch, ch
    jz @13
    test ecx, 0FF0000h
    jz @14
    test ecx, 0FF000000h
    jnz @B

    sub eax, 1
    ret 4

@0:
    sub eax, 16
    ret 4

@1:
    sub eax, 15
    ret 4

@2:
    sub eax, 14
    ret 4

@3:
    sub eax, 13
    ret 4

@4:
    sub eax, 12
    ret 4

@5:
    sub eax, 11
    ret 4

@6:
    sub eax, 10
    ret 4

@7:
    sub eax, 9
    ret 4

@8:
    sub eax, 8
    ret 4

@9:
    sub eax, 7
    ret 4

@10:
    sub eax, 6
    ret 4

@11:
    sub eax, 5
    ret 4

@12:
    sub eax, 4
    ret 4

@13:
    sub eax, 3
    ret 4

@14:
    sub eax, 2
    ret 4

AzmtStrLen2A ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 
; Author:           [url=http://www.agner.org/optimize/asmexamples.zip]Agner Fog[/url]
; Date created:     2008-07-06
; Last modified:    2008-07-06

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
_strlen proc src:DWORD
        mov      eax,  [esp+4]         ; get pointer to string
        mov      ecx,  eax             ; copy pointer
        pxor     xmm0, xmm0            ; set to zero
        and      ecx,  15              ; lower 4 bits indicate misalignment
        and      eax,  -16             ; align pointer by 16
        movdqa   xmm1, [eax]           ; read from nearest preceding boundary
        pcmpeqb  xmm1, xmm0            ; compare 16 bytes with zero
        pmovmskb edx,  xmm1            ; get one bit for each byte result
        shr      edx,  cl              ; shift out false bits
        shl      edx,  cl              ; shift back again
        bsf      edx,  edx             ; find first 1-bit
        jnz      L2                    ; found
        
        ; Main loop, search 16 bytes at a time
L1:     add      eax,  16              ; increment pointer by 16
	if 0
		movaps   xmm1, [eax]           ; read 16 bytes aligned
	else
		movdqa   xmm1, [eax]           ; read 16 bytes aligned
	endif
        pcmpeqb  xmm1, xmm0            ; compare 16 bytes with zero
        pmovmskb edx,  xmm1            ; get one bit for each byte result
        bsf      edx,  edx             ; find first 1-bit
        jz       L1                    ; loop if not found
        
L2:     ; Zero-byte found. Compute string length        
        sub      eax,  [esp+4]         ; subtract start address
        add      eax,  edx             ; add byte index
        ret 4       
_strlen endp
_strlene:

.data
align 16
Minus1	dq	-1
.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
; align 16 has no influence
strlen32 proc src:DWORD			; jj 9 March 2007, 92 (down from 103) bytes; 0.176 cycles/byte at 16k
	; ************** obsolete, replaced by strlen32s **************
	mov eax, [esp+4]			; get pointer to string: -- this part taken from Agner Fog ----
	mov ecx, eax			; copy pointer
	pxor xmm0, xmm0			; set to zero for comparison
	and eax, -16			; align pointer by 16 (by 32 will not work)
	and ecx, 15			; lower 4 bits indicate misalignment
;	movaps xmm1, [eax]		; this combo approx. 2 cycles slower 
;	pcmpeqb xmm0, xmm1		; for short strings, no gain for long strings
	pcmpeqb xmm0, [eax]		; read 16 from nearest preceding boundary and compare with zero
	pmovmskb edx, xmm0		; get one bit for each byte result
	shr edx, cl			; shift out false bits	** compliments to Agner, **
	shl edx, cl			; shift back again	** this is called genius ;-) **
	bsf edx, edx			; find first 1-bit
	jnz fdr1				; found in round 1
	add eax, 16			; correct aligned pointer for bytes already treated above (lea exactly same cycles)
	pxor xmm0, xmm0			; reset to zero for comparisons below
	pxor xmm1, xmm1			; align 16 no good, costs about one cycle extra

@@:	pcmpeqb xmm0, [eax]		; ------ this part taken from Lingo, with adaptions ------
	pcmpeqb xmm1, [eax+16]		; ecx is pointer to initial string, 16-byte aligned
	por xmm1, xmm0
	; add eax, 32 ; is marginally slower than lea
	lea eax, [eax+32]			; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	pmovmskb edx, xmm1
	test edx, edx
	jz @B

	pmovmskb ecx, xmm0
	shl edx, 16			; bswap works, too, but one cycle slower
	or edx, ecx
	bsf edx, edx
	sub eax, 32			; subtract initial bytes
fdr1:	add eax, edx
	sub eax, [esp+4]
	ret 4
strlen32 endp
strlen32e:

strlen32b proc src:DWORD			; jj 9 March 2007, 92 (down from 103) bytes; 0.176 cycles/byte at 16k
	; ************** obsolete, replaced by strlen32s **************
	mov ecx, [esp+4]			; get pointer to string: -- this part taken from Agner Fog ----
	mov al, [ecx]			; test for Null$
	test al, al
	je nullptr
	pxor xmm0, xmm0			; set to zero for comparison
	mov eax, ecx			; copy pointer
;	.if eax==offset szTest_15
;		int 3
;	.endif
	pxor xmm1, xmm1
	and eax, -16			; align pointer by 16
	and ecx, 15			; lower 4 bits indicate misalignment
	pcmpeqb xmm1, [eax]		; read 16 from nearest preceding boundary and compare with zero
	; lea eax, [eax+16]
	add eax, 16
	pcmpeqb xmm0, [eax]		; ecx is pointer to initial string, 16-byte aligned
	por xmm1, xmm0
	pmovmskb edx, xmm1		; get one bit for each byte result; - OK, isnull, stays null, Z=1, Bad: notnull, willbenull, z=0
	shr edx, cl			; shift out false bits	** compliments to Agner, **
	shl edx, cl			; shift back again	** this is called genius ;-) **
	test edx, edx
	jnz fdr1
	add eax, 16			; correct aligned pointer for bytes already treated above (lea exactly same cycles)
	; pxor xmm0, xmm0	(must be 0)	; reset to zero for comparisons below
				; if SpecialTest eq 0
	pxor xmm1, xmm1			; see szTest_Fail - this is needed
	; endif
@@:	pcmpeqb xmm0, [eax]		; ------ this part taken from Lingo, with adaptions ------
	pcmpeqb xmm1, [eax+16]		; ecx is pointer to initial string, 16-byte aligned
	por xmm1, xmm0
	; add eax, 32 ; is marginally slower than lea
	lea eax, [eax+32]			; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	pmovmskb edx, xmm1
	test edx, edx
	jz @B
	sub eax, 32			; subtract initial bytes

fdr1:	pmovmskb ecx, xmm0
	shl edx, 16
	or edx, ecx
	bsf edx, edx
	add eax, edx
	sub eax, [esp+4]
nullptr:	ret 4
strlen32b endp
strlen32be:

align 16	; jj2007, 12 March 2007, 85 bytes; 0.176 cycles/byte at 16k on Celeron M (0.3 on P4)
strlen32s proc src:DWORD		; with lots of inspiration from Lingo, NightWare and Agner Fog
	mov eax, [esp+4]		; get pointer to string
	movups xmm1, [eax]	; move 16 bytes into xmm1, unaligned (adapted from Lingo/NightWare)
	pxor xmm0, xmm0		; zero for comparison (no longer needed for xmm1 - thanks, NightWare)
	pcmpeqb xmm1, xmm0	; set bytes in xmm1 to FF if nullbytes found in xmm1
	pmovmskb eax, xmm1	; set byte mask in eax
	bsf eax, eax		; bit scan forward
	jne Lt16			; less than 16 bytes, we can return the index in eax

@@:	push ecx			; all registers preserved, except eax = return value
	push edx			; eax will be pointer to initial string, 16-byte aligned
	mov ecx, [esp+12]		; get pointer to string
	and ecx, -16		; align initial pointer to 16-byte boundary
	lea eax, [ecx+16]		; aligned pointer + 16 (first 0..15 dealt with by movups above)

@@:	pcmpeqb xmm0, [eax]	; ---- inner loop inspired by Lingo, with adaptions -----
	pcmpeqb xmm1, [eax+16]	; compare packed bytes in [m128] and xmm1 for equality
	por xmm1, xmm0		; or them: one of the mem locations may contain a nullbyte
	lea eax, [eax+32]		; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	pmovmskb edx, xmm1	; set byte mask in edx
	test edx, edx
	jz @B

	pmovmskb ecx, xmm0	; set byte mask in ecx (has to be repeated, sorry)
	shl edx, 16		; create space for the ecx bytes
	or edx, ecx		; combine xmm0 and xmm1 results
	bsf edx, edx		; bit scan for the index
	lea eax, [eax+edx-32]	; add scan index, subtract initial bytes
	pop edx
	sub eax, [esp+8]
	pop ecx
Lt16:	ret 4
strlen32s endp
strlen32se:







align 16	; jj2007, 12 March 2007, 77 bytes; 0.176 cycles/byte at 16k
strlen32c proc src:DWORD		; with lots of inspiration from Lingo, NightWare and Agner Fog
	push ecx			; all registers preserved, except eax = return value
	mov ecx, [esp+8]		; get pointer to string
	pxor xmm0, xmm0		; zero for comparison (no longer needed for xmm1 - thanks, NightWare)
	movups xmm1, [ecx]	; move 16 bytes into xmm1, unaligned (adapted from Lingo/NightWare)
	pcmpeqb xmm1, xmm0	; set bytes in xmm1 to FF if nullbytes found in xmm1
	pmovmskb eax, xmm1	; set byte mask in eax
	bsf eax, eax		; bit scan forward
	jne Lt16			; less than 16 bytes, we can return the index in eax
@@:	and ecx, -16		; align initial pointer to 16-byte boundary
	lea eax, [ecx+16]		; aligned pointer + 16 (first 0..15 dealt with by movups above)
	push edx

@@:	pcmpeqb xmm0, [eax]	; ---- inner loop may contain traces of Lingo -----
	pcmpeqb xmm1, [eax+16]	; eax is pointer to initial string, 16-byte aligned
	pmovmskb ecx, xmm0	; set byte mask in ecx
	pmovmskb edx, xmm1	; set byte mask in edx
	lea eax, [eax+32]		; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	cmp ecx, edx
	je @B

	shl edx, 16
	or edx, ecx
	bsf edx, edx
	lea eax, [eax+edx-32]	; add scan index, subtract initial bytes
	pop edx
	sub eax, [esp+8]
Lt16:	pop ecx
	ret 4
strlen32c endp
strlen32ce:

align 16
db		8Dh,0A4h,24h,0,0,0,0,8Dh,48h,0,10h 
strlen64B		proc szBuffer : dword
	pop ecx
	pop eax
	movdqu xmm2, [eax]
	pxor xmm0, xmm0
	pcmpeqb xmm2, xmm0
	pxor xmm1, xmm1
	pmovmskb edx, xmm2
	test edx, edx
	jz @f
	bsf eax, edx
	jmp ecx
@@:
	lea ecx, [eax+16]
	and eax, -16
@@:
	pcmpeqb xmm0, [eax+16]
	pcmpeqb xmm1, [eax+32]
	por xmm1, xmm0
	add eax, 32
	pmovmskb edx, xmm1
	test edx, edx
	jz @B
	shl edx, 16
	sub eax, ecx
	pmovmskb ecx, xmm0
	or edx, ecx
	mov ecx, [esp-8]
	bsf edx, edx
	add eax, edx
	jmp ecx
strlen64B endp
strlen64Be:

align 16
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	; align 15
strlen64xB		proc szBuffer : dword		; old 85 bytes version, before [url=http://www.masm32.com/board/index.php?topic=1807.msg81266#msg81266]this post[/url]; commented by jj
; db 0cch
	mov eax, [esp+4]		; pointer to src
	movdqu xmm2, [eax]	; move 16 bytes into xmm2
	pxor xmm0, xmm0		; zero for comparison
	pcmpeqb xmm2, xmm0	; set bytes in xmm2 to FF if nullbytes found in xmm2
	pxor xmm1, xmm1		; zero for comparison
	pmovmskb edx, xmm2	; set byte mask in edx
	lea ecx, [eax+16]		; ecx=eax+16
	test edx, edx
	jnz Ex_0
	and eax, -16		; align eax to para
@@:	add eax, 32
	pcmpeqb xmm0, [eax-16]
	pcmpeqb xmm1, [eax]
	por xmm1, xmm0
	pmovmskb edx, xmm1
	test edx, edx
	jz @B

	shl edx, 16
	sub eax, ecx
	pmovmskb ecx, xmm0
		;sub	eax, [esp+4]
	or edx, ecx
		;sub	eax, 16
	bsf edx, edx
	add eax, edx
	ret 4
align 16
Ex_0:
	bsf eax, edx
	ret 4
strlen64xB endp
strlen64xBe:

align 16
strlen64A	proc szBuffer : dword

	mov eax, [esp+4]
	movdqu xmm2, [eax]
	pxor xmm0, xmm0
	and eax, -16
	pcmpeqb xmm0, [eax+1*16]
	pxor xmm1, xmm1
	pcmpeqb xmm1, xmm2
	por xmm1, xmm0
	pmovmskb edx, xmm1
	test edx, edx
	jnz Ex_1
@@:
	pcmpeqb xmm0, [eax+2*16]
	pcmpeqb xmm1, [eax+3*16]
	por xmm1, xmm0
	pmovmskb edx, xmm1
	add eax, 2*16
	test edx, edx
	jz @b
	shl edx, 16
	pmovmskb ecx, xmm0
	sub eax, [esp+4]
	or edx, ecx
	bsf edx, edx
	add eax, edx
	ret 4
align 16
Ex_1:
	shl edx, 16
	add eax, 1*16
	pmovmskb ecx, xmm0
	sub eax, [esp+4]
	or edx, ecx
	bsf edx, edx
	add eax, edx
	ret 4
strlen64A endp
strlen64Ae:

align 16
strlen64	proc szBuffer : dword
	pxor xmm0, xmm0
	mov eax, [esp+4]
	pcmpeqb xmm0, [eax]
	pxor xmm1, xmm1		; this is a comment with trailing blanks
	pcmpeqb xmm1, [eax+16]
	pxor xmm2, xmm2
	por xmm1, xmm0
	pmovmskb edx, xmm1
	test edx, edx
	jz @f
	shl edx, 16
	pmovmskb ecx, xmm0
	sub eax, [esp+4]
	or edx, ecx
	bsf edx, edx
	add eax, edx
	ret 4
align 16
@@:
	pcmpeqb xmm2, [eax+32]
	pcmpeqb xmm1, [eax+48]
	por xmm1, xmm2
	pmovmskb edx, xmm1
	add eax, 32
	test edx, edx
	jz @b
	shl edx, 16
	pmovmskb ecx, xmm2
	sub eax, [esp+4]
	or edx, ecx
	bsf edx, edx
	add eax, edx
	ret 4
strlen64 endp

ALIGN 16
DB 4 DUP (90h)
markl_szlen proc pString:DWORD

    push ebx
    push esi

    mov esi, [esp+12]

    ;------------------------------------------
    ; Special handling for zero-length string.
    ;------------------------------------------

    mov eax, [esi]
    or  eax, eax
    jz  fini
  @@:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov ecx, [esi+8]
    mov edx, [esi+12]
    add esi, 16
    and eax, 0ff000000h
    jz  dw0
    and ebx, 0ff000000h
    jz  dw1
    and ecx, 0ff000000h
    jz  dw2
    and edx, 0ff000000h
    jz  dw3
    jmp @B
 dw0:
    sub esi, 4
 dw1:
    sub esi, 4
 dw2:
    sub esi, 4
 dw3:
    sub esi, 4
    cmp BYTE PTR [esi],0
    je  @F
    inc esi
    jmp @B
 @@:   
    sub esi, [esp+12]
    mov eax, esi
 fini:
    pop esi
    pop ebx

    ret 4

markl_szlen endp


align 16	
StrSizeA proc lpStrA:DWORD
	
@@:	mov edx,DWORD ptr [esp+4]
	pxor xmm1,xmm1
	mov ecx,edx
      neg ecx
      align 16
@@:	movdqu xmm0,OWORD ptr [edx] 
      lea edx,[edx+16]	
      pcmpeqb xmm0,xmm1
      pmovmskb eax,xmm0
	test eax,eax	
      jz @B 

@@:	lea ecx,[edx+ecx-16]
      xor edx,edx
      bsf edx,eax
	lea eax,[ecx+edx]
	ret 4

StrSizeA endp

align 16
StringLength_Mmx_Min proc lpStr:DWORD

    mov eax,DWORD ptr [esp+4]
    mov ecx,eax
    pxor MM0,MM0
    Label1: pcmpeqb MM0,QWORD PTR [eax]
    pmovmskb edx,MM0
    add eax,8
    test edx,edx
    jz Label1
    sub eax,ecx
    bsf edx,edx
    lea eax,[eax+edx-8]
     
    ret 4
StringLength_Mmx_Min endp

NWStrLen PROC src:DWORD	;; [url=http://www.masm32.com/board/index.php?topic=1807.msg81075#msg81075]Nightware, 10.03.2009[/url]
	push ecx		;; empiler ecx
	push edx		;; empiler edx
	push esi
	mov esi, [esp+4+3*4]
	mov edx,esi		;; placer l'adresse de dpart dans edx
	pxor XMM0,XMM0		;; ) effacer XMM0 et XMM1 (ce sera nos registres de comparaison)
	pxor XMM1,XMM1		;; )
; ici, on teste un bloc de x caractres (dpend de l'alignement), pour voir s'il existe un 0
	movdqu XMM2,OWORD PTR [edx]		;; placer l'oword  l'adresse en edx dans XMM2
	and edx,0FFFFFFF0h		;; conserver l'alignement 16 prcdant dans edx
	pcmpeqb XMM0,XMM2		;; comparer XMM2  XMM0
	pcmpeqb XMM1,OWORD PTR [edx+16]		;; comparer l'oword  l'adresse en edx+16  XMM1
	por XMM1,XMM0		;; fusionner XMM1 et XMM0
	pmovmskb eax,XMM1		;; gnrer le masque de XMM1 dans eax
	test eax,eax		;; fixer les flags de eax
	jz Label1		;; si c'est gal  0 (pas de 0 trouv), aller Label1
; ici, on va chercher le 0 dans le bloc de x caractres
	shl eax,16		;; dcaler eax (qui contient dj le masque XMM1)  gauche d'un dword/2
	mov ecx,esi		;; placer l'adresse originelle dans ecx
	sub ecx,edx		;; soustraire l'alignement prcdant
	shr eax,cl		;; dcaler eax  droite, correspondant au dcalage de l'alignement
	pmovmskb ecx,XMM0		;; gnrer le masque de XMM0 dans ecx
	or eax,ecx		;; fusionner ecx  eax
	bsf eax,eax		;; scanner le premier bit arm de eax  partir de la droite
	pop esi
	pop edx		;; dsempiler edx
	pop ecx		;; dsempiler ecx
	ret 4		;; retourner (sortir de la procdure)

	nop		;; ) alignement ncessaire pour un meilleur rendement
	nop		;; )
	nop		;; )
; nop		;; )
; nop		;; )
; nop		;; )
; nop		;; )
; nop		;; )
; ici, on teste un bloc de 32 caractres, pour voir s'il existe un 0
Label1: add edx,OWORD*2		;; ajouter 32 (notre pas de progression)  edx
	pcmpeqb XMM0,OWORD PTR [edx]		;; comparer l'oword  l'adresse en edx  XMM0
	pcmpeqb XMM1,OWORD PTR [edx+16]		;; comparer l'oword  l'adresse en edx+16  XMM1
	por XMM1,XMM0		;; fusionner XMM1 et XMM0
	pmovmskb eax,XMM1		;; gnrer le masque de XMM1 dans eax
	test eax,eax		;; fixer les flags de eax
	jz Label1		;; si c'est gal  0 (pas de 0 trouv), aller Label1
; ici, on va chercher le 0 dans le bloc de 32 caractres
	pmovmskb ecx,XMM0		;; gnrer le masque de XMM0 dans ecx
	shl eax,16		;; dcaler eax (qui contient dj le masque XMM1)  gauche d'un dword/2
	or eax,ecx		;; fusionner ecx  eax
	sub edx,esi		;; enlever l'adresse de dpart  edx
	bsf eax,eax		;; scanner le premier bit arm de eax  partir de la droite
	add eax,edx		;; ajouter edx  eax pour obtenir la taille finale
	pop esi
	pop edx		;; dsempiler edx
	pop ecx		;; dsempiler ecx
	ret 4		;; retourner (sortir de la procdure)
NWStrLen ENDP

.data?
	osv		OSVERSIONINFO <?>
	CpuFlags	dd ?
	CpuExFlags	dd ?
	CpuMMX		dd ?
	CpuSSE		dd ?
	CpuFxSR		dd ?
	CpuManu		dd 20 dup (?)
	CpuInfo		dd 100 dup (?)
	CpuBrand	dd 13 dup (?)		; 48 bytes
	step	dd ?
	model	dd ?
	family	dd ?
	ptype	dd ?
	extmodel	dd ?
	extfamily	dd ?
	CpuAMD	dd ?
	CpuIntel	dd ?
.data
	MbCopyDestAlign	dd -1			; default
	txModel	db "Model        ", 9, 0
	txFam	db 13, 10, "Family       ", 9, 0
	txStep	db 13, 10, "Step           ", 9, 0
	txType	db 13, 10, "Type          ", 9, 0
	txExtM	db 13, 10, "Ext model   ", 9, 0
	txExtF	db 13, 10, "Ext family   ", 9, 0
	txCpuMan	db 13, 10, "Manufacturer", 9, 0
	txDesc	db 13, 10, "Description", 9, 0
	txBrand	db 13, 10, "Brand name", 9, 0
	txP1	db "P1 (1993+)", 0
	txPro	db "Pentium Pro (1995+)", 0
	txP2	db "P2 (1997+)", 0
	txP3	db "P3 (2000+)", 0
	txP4	db "P4 (2000+)", 0
	txIta1	db "Itanium 1 (2001+)", 0
	txIta2	db "Itanium 2 (2002+)", 0
	txPM	db "Pentium M (2003+)", 0
	txCore	db "Core (2006+)", 0
	txCore2	db "Core Duo (2006+)", 0
	txP4Prescott	db "Pentium 4 Prescott (2005+)", 0
	txUnknownP4	db "Pentium 4 (?)", 0
	txUnknownAMD	db "AMD (?)", 0
	txUnknown	db "?", 0
.code
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCPU proc mode:DWORD

; Usage:

; push 0
; call ShowCPU 	; for info only

; push -1
; call ShowCPU	; for printing the long version

; push 1
; call ShowCPU	; for printing the short version

  push edi
  push esi
  push ebx
  xor eax, eax
  db 0Fh, 0A2h		; cpuid 0
  mov CpuManu, ebx
  mov CpuManu[4], edx
  mov CpuManu[8], ecx
  .if ecx=="DMAc"
	inc CpuAMD				; it's an AMD
  .elseif ecx=="letn"
  	inc CpuIntel				; it's an Intel
  .endif
  mov esi, 80000002h
  mov edi, offset CpuBrand
  .Repeat
	mov eax, esi
	db 0Fh, 0A2h			; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc esi
  .Until esi==80000005h
;  MsgBox 0, offset CpuBrand, "Brand", MB_OK
  push 1
  pop eax
  db 0Fh, 0A2h					; cpuid 1
  mov CpuFlags, edx
  mov CpuExFlags, ecx
  and CpuMMX, 0
  and CpuSSE, 0

  mov ebx, eax
  and eax, 15
  mov step, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov model, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov family, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov ptype, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov extmodel, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov extfamily, eax
  mov edi, offset CpuInfo
  and CpuInfo, 0
  mov eax, [esp+4+12]	; get arg from stack (we pushed ebx)
  .if eax==-1
;	invoke lstrcat, edi, chr$("CPU family ")
;	invoke lstrcat, edi, str$(family)
;	invoke lstrcat, edi, chr$(", model ")
;	invoke lstrcat, edi, str$(model)
;	invoke lstrcat, edi, ", "
 
	invoke lstrcat, edi, offset txModel
	invoke lstrcat, edi, str$(model)

	invoke lstrcat, edi, offset txFam
	invoke lstrcat, edi, str$(family)

	.if step
	invoke lstrcat, edi, offset txStep
	invoke lstrcat, edi, str$(step)
	.endif

	.if ptype
	invoke lstrcat, edi, offset txType
	invoke lstrcat, edi, str$(ptype)
	.endif

	.if extmodel
	invoke lstrcat, edi, offset txExtM
	invoke lstrcat, edi, str$(extmodel)
	.endif

	.if extfamily
	invoke lstrcat, edi, offset txExtF
	invoke lstrcat, edi, str$(extfamily)
	.endif

	invoke lstrcat, edi, offset txCpuMan
	invoke lstrcat, edi, offset CpuManu

	invoke lstrcat, edi, offset txDesc
  .endif
  .if CpuAMD
	invoke lstrcat, edi, chr$("AMD ")
	; and MbCopyDestAlign, 0	; in case AMD runs better on source data alignment
  .elseif CpuIntel
	invoke lstrcat, edi, chr$("Intel ")
  .endif
  .if family==5
	mov edx, offset txP1
  .elseif family==6
	.if model<=1
		mov edx, offset txPro
	.elseif model==3 || model==5 || model==6
		mov edx, offset txP2
	.elseif model==7 || model==8 || model==10 || model==11
		mov edx, offset txP3
	.elseif model==9 || model==13
		mov edx, offset txPM
	.elseif model==14
		mov edx, offset txCore
	.elseif model==15
		mov edx, offset txCore2
	.endif
  .elseif family==7	; Itanium
		mov edx, offset txIta1
  .elseif family==15
	.if model==0
		mov edx, offset txP4
	.elseif model<=2
		mov edx, offset txIta2
	.elseif model==4
		mov edx, offset txP4Prescott
	.elseif model==6
		mov edx, chr$("Pentium dual-core x64")
	.elseif model==11 && CpuAMD
		mov edx, chr$("AMD XP dual-core x64")
	.elseif CpuAMD
		mov edx, offset txUnknownAMD
	.else
		mov edx, offset txUnknownP4
	.endif
  .elseif CpuAMD
	mov edx, offset txUnknownAMD
  .else
	mov edx, offset txUnknown
  .endif
  invoke lstrcat, edi, edx
  mov edx, CpuFlags
  bt edx, 25
  jnc @F
  inc CpuSSE	; edx bit 25, SSE1
@@:

  bt edx, 26	; edx bit 26, SSE2
  jnc @F
  inc CpuSSE
@@:

  mov ecx, CpuExFlags
  bt ecx, 0		; ecx bit 0, SSE3
  jnc @F
  inc CpuSSE
@@:
  bt ecx, 9		; ecx bit 9, SSE4
  jnc @F
  inc CpuSSE
@@:
  bt edx, 23
  .if Carry?
	inc CpuMMX
	.if CpuSSE==0
		invoke lstrcat, edi, chr$(", MMX")
	.endif
  .else
	invoke lstrcat, edi, chr$(", no MMX")
  .endif
  mov edx, CpuFlags
  bt edx, 24
  jnc @F
  inc CpuFxSR	; supports FXSAVE, FXRSTOR
@@:
  .if CpuSSE
	invoke lstrcat, edi, chr$(", SSE")
	invoke lstrcat, edi, str$(CpuSSE)
  .endif
  invoke lstrcat, edi, offset txBrand
  invoke lstrcat, edi, offset CpuBrand
  mov eax, [esp+4+12]
  .if eax==-1
	print edi, 13, 10
  .elseif eax==1
	print offset CpuBrand
	.if CpuSSE
		print chr$(32, 40, "SSE")
		print str$(CpuSSE), 41
	.endif
  .endif
  if 0
  mov osv.dwOSVersionInfoSize, sizeof osv
  invoke GetVersionEx, addr osv
  lea edx, osv.szCSDVersion
  MsgBox 0, edx, "Hi", MB_OK
  exit
  endif
  pop ebx
  pop esi
  pop edi
  ret 4
ShowCPU endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
MyTest proc uses esi edi ebx TestAlgo:DWORD, pName:DWORD
  mov esi, offset szTest_4k
  offs=0
  add esi, offs
  mov edi, 4096-offs
  mov ebx, 4096
  .Repeat
  	push [esi-4]
  	mov dword ptr [esi-4], 0			; patch: insert nullbytes before the string
  	push esi
	call TestAlgo
	inc esi
  	push esi
	call TestAlgo
	dec esi
;	.if ebx==1
;		int 3
;	.endif
  	push esi
	call TestAlgo
  	pop ecx
  	mov dword ptr [esi-4], ecx			; restore patched byte
	.Break .if eax!=edi ; && ebx<12
	if 0
	push eax
	print str$(edi), 9
	pop eax
	print str$(eax), 13, 10
	endif
	inc esi
	dec edi
	dec ebx
  .Until Sign?
  .if ebx!=offs-1
  	push eax
  	% print "ERROR in "
  	print pName, " at ebx="
  	print str$(ebx), ": "
  	pop eax
  	print str$(eax), " bytes instead of "
  	print str$(edi), 13, 10
  .endif
;  print "---------- OK -----------", 13, 10
ret
MyTest endp
; 

end start

OPT_Assembler	JWasm
OPT_Res	0
OPT_Tmp2Asm	1
OPT_Wait	0
